package SUGI30;

import java.io.File;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;

import java.awt.Graphics2D;
import java.awt.RenderingHints;

import java.awt.Color;

public class Graphics {


	// slide


	private String readSource;
	private BufferedImage readBuffer;

	void readImage (String source) throws Exception {
		readSource = null;
		readBuffer = ImageIO.read (new File(source));
		readSource = source;
	}
	void showReadBuffer () {
		show ( readBuffer, readSource );
	}
	void show (BufferedImage img, String title) {
		JOptionPane.showMessageDialog(null,null,title,
			JOptionPane.PLAIN_MESSAGE, new ImageIcon(img));
	}


	// slide


	private BufferedImage buffer;
	private Graphics2D g;
	private double antiAlias;

	void createBuffer (double width, double height) {
		buffer = new BufferedImage ((int)width, (int)height
		                            , BufferedImage.TYPE_INT_RGB);
		g = buffer.createGraphics();
		setAntiAlias (1d ); // 1 as double
	}
	void setAntiAlias (double smooth) {
		if (smooth != 0d) {
			g.setRenderingHint (RenderingHints.KEY_TEXT_ANTIALIASING
							   ,RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
	        g.setRenderingHint (RenderingHints.KEY_ANTIALIASING
	        				   ,RenderingHints.VALUE_ANTIALIAS_ON);
   		}
   		else {
			g.setRenderingHint (RenderingHints.KEY_TEXT_ANTIALIASING
							   ,RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);
	        g.setRenderingHint (RenderingHints.KEY_ANTIALIASING
	        				   ,RenderingHints.VALUE_ANTIALIAS_OFF);
		}
	}


	// slide


	String saveAs (String type, String name) {
        String savedAs = "";

        try {
            File file = new File(name);
            savedAs = file.getCanonicalPath();
            ImageIO.write (this.buffer, type, new File(savedAs));
        }
        catch (Exception e) {
            savedAs = "";
        }

        return savedAs;
    }

	void show (String title, String message) {
		JOptionPane.showMessageDialog(null,message,title,
			JOptionPane.PLAIN_MESSAGE, new ImageIcon(buffer));
	}

	void show () {
		JOptionPane.showMessageDialog(null,null,null,
			JOptionPane.PLAIN_MESSAGE, new ImageIcon(buffer));
	}


	// slide

	void setColor (double r, double g, double b) {
	   this.g.setColor (new Color ((int)r,(int)g,(int)b));
	}

	void drawLine (double x1, double y1, double x2, double y2) {
	   g.drawLine ( (int) x1,  (int) y1,  (int) x2,  (int) y2);
	}

	void fillRect (double x, double y, double width, double height) {
	   g.fillRect ( (int) x,  (int) y,  (int) width,  (int) height);
	}

	void drawOval (double x, double y, double width, double height) {
	   g.drawOval ( (int) x,  (int) y,  (int) width,  (int) height);
	}

	void fillOval (double x, double y, double width, double height) {
	   g.fillOval ( (int) x,  (int) y,  (int) width,  (int) height);
	}

}
